=== debian/changelog ===
deal.ii (6.3.1-1ubuntu1) natty; urgency=low

  * debian/control: updated dependencies for libslepc3.1 transition
  * slepc-3.1.patch: taken from upstream to adapt to slepc3.1 API change

 -- Fabrice Coutadeur <fabricesp@ubuntu.com>  Mon, 14 Mar 2011 20:44:55 +0000

deal.ii (6.3.1-1) unstable; urgency=low

  [ Adam C. Powell, IV ]
  * Changed to source format 3.0 (quilt).
  * Changed maintainer to debian-science with Adam Powell as uploader.
  * Added source lintian overrides about Adam Powell's name.
  * Added Vcs info on git repository.
  * Bumped Standards-Version.
  * Changed stamp-patch to patch target and fixed its application criterion.
  * Moved make_dependencies and expand_instantiations to a versioned directory
    to avoid shlib package conflicts.

  [ Denis Barbier ]
  * New upstream release (closes: #562332).
    + Added libtbb support.
    + Forward-ported all patches.
  * Updates for new PETSc version, including workaround for different versions
    of petsc and slepc.
  * Add debian/watch.
  * Update to debhelper 7.
  * Added pdebuild patch.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Thu, 29 Jul 2010 13:47:01 -0400

deal.ii (6.2.1-2) unstable; urgency=low

  * Added libboost-python-dev to Build-Depends (closes: #549716).
  * Bumped Standards-Version.
  * Added README.source.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Tue, 03 Nov 2009 08:07:34 -0500

deal.ii (6.2.1-1) unstable; urgency=low

  * New upstream release.
  * Removed backslashes from dependencies (closes: #535284).
  * Added libboost-graph-dev to Build-Depends (closes: #533629).
  * Updated Standards-Version.
  * Updated debhelper Build-Depends version.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Tue, 21 Jul 2009 08:02:26 -0400

deal.ii (6.2.0-3) unstable; urgency=low

  * Added libslepc3.0.0-dev to Build-Depends (closes: #529162).
  * Completed Trilinos linkage, which requires a version of Trilinos including
    a working Sacado package.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Thu, 21 May 2009 07:41:33 -0400

deal.ii (6.2.0-2) unstable; urgency=low

  * Added Trilinos linkage.
  * Changed compilers to mpicc and mpicxx to make trilinos tests work.
  * Fixed library variables using a sed hack.
  * Added PIC flag to soname test.
  * Fixed a couple of other lintian warnings.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Fri, 08 May 2009 23:13:50 -0400

deal.ii (6.2.0-1) unstable; urgency=low

  * New upstream which builds with PETSc 3.0.
  * Disabled build of contrib/functionparser.
  * Minor update to metis patch.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Fri, 08 May 2009 10:44:16 -0400

deal.ii (6.1.0-5) unstable; urgency=low

  * Removed the section of the copyright file regarding contrib/dx/* because
    that directory is under the same copyright and license as the rest of the
    code (Files: *).

 -- Adam C. Powell, IV <hazelsct@debian.org>  Tue, 30 Dec 2008 02:42:29 -0500

deal.ii (6.1.0-4) unstable; urgency=low

  * Added --with-boost to configure to use Debian boost during compilation
    instead of contrib/boost.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Mon, 17 Nov 2008 21:47:37 -0500

deal.ii (6.1.0-3) unstable; urgency=low

  * Found and added additional copyright holders to debian/copyright.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Thu, 06 Nov 2008 23:02:27 -0500

deal.ii (6.1.0-2) unstable; urgency=low

  * Patched doxygen docs to eliminate equation latex errors.
  * Made build-doc rule depend on stamp-configure.
  * -dev package now depends on many -dev packages, including boost.
  * Removed compression from -examples package .cc and .inp files.
  * Cleaned up Make.global_options and example Makefiles so they work.
  * Included instructions for running examples in README.Debian.html.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Wed, 17 Sep 2008 11:01:46 -0400

deal.ii (6.1.0-1) unstable; urgency=low

  * First package (closes: #494729).

 -- Adam C. Powell, IV <hazelsct@debian.org>  Thu, 28 Aug 2008 14:46:46 -0400
